let lib = {
// (A) INIT
iDB: null,
iTX: null,
iName: "Моя библиотека", // объект idb и транзакция
hForm: null,
hID: null,
hCode: null, // HTML-элементы
hTitle: null,
hAuthor: null,
hLoc: null,
hList: null,
init: () => {
// (A1) ПРОВЕРКА ПОДДЕРЖКИ IDB
window.indexedDB = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
if (!window.indexedDB) {
alert("Ваш браузер не поддерживает индексированную базу данных.");
return false;
}
// (A2) ОТКРЫТЬ БАЗУ ДАННЫХ "MYLIB"
let req = window.indexedDB.open(lib.iName, 1);
// (A3) ОШИБКА БАЗЫ ДАННЫХ
req.onerror = (evt) => {
alert("Indexed DB init error - " + evt.message);
console.error(evt);
};
// (A4) ТРЕБУЕТСЯ ОБНОВЛЕНИЕ
req.onupgradeneeded = (evt) => {
// (A4-1) НАЧАТЬ ОБНОВЛЕНИЕ
lib.iDB = evt.target.result;
lib.iDB.onerror = (evt) => {
alert("Indexed DB upgrade error - " + evt.message);
console.error(evt);
};
// (A4-2) VERSION 1
if (evt.oldVersion < 1) {
let store = lib.iDB.createObjectStore(lib.iName, {
keyPath: "id",
autoIncrement: true
});
store.createIndex("code", "code");
store.createIndex("title", "title");
store.createIndex("author", "author");
}
};
// (A5) ОТКРЫТЬ БАЗУ ДАННЫХ ОК
req.onsuccess = (evt) => {
// (A5-1) РЕГИСТРАЦИЯ ОБЪЕКТОВ IDB
lib.iDB = evt.target.result;
lib.iTX = () => {
return lib.iDB.transaction(lib.iName, "readwrite").objectStore(lib.iName);
};
// (A5-2) ПОЛУЧИТЬ HTML-ЭЛЕМЕНТЫ
lib.hForm = document.getElementById("libFormWrap");
lib.hID = document.getElementById("formID");
lib.hCode = document.getElementById("formCode");
lib.hTitle = document.getElementById("formTitle");
lib.hAuthor = document.getElementById("formAuthor");
lib.hLoc = document.getElementById("formLoc");
lib.hList = document.getElementById("libList");
// (A5-3) СПИСОК КНИГ
lib.draw();
};
},
// (B) TOGGLE ДОБАВИТЬ/РЕДАКТИРОВАТЬ ФОРМУ КНИГ
toggle : (id) => {
// (B1) СКРЫТЬ ФОРМУ
if (id == false) {
lib.hID.value = "";
lib.hCode.value = "";
lib.hTitle.value = "";
lib.hAuthor.value = "";
lib.hLoc.value = "";
lib.hForm.classList.remove("show");
}
// (B2) ПОКАЗАТЬ ФОРМУ
else {
// (B2-1) "РЕЖИМ РЕДАКТИРОВАНИЯ
if (Number.isInteger(id)) {
let req = lib.iTX().get(id);
req.onsuccess = (evt) => {
lib.hID.value = id;
lib.hCode.value = req.result.code;
lib.hTitle.value = req.result.title;
lib.hAuthor.value = req.result.author;
lib.hLoc.value = req.result.location;
};
}
// (B2-2) ПОКАЗАТЬ ФОРМУ
lib.hForm.classList.add("show");
}
},
// (C) ДОБАВИТЬ НОВУЮ КНИГУ
add: () => {
// (C1) ДАННЫЕ ДЛЯ СОХРАНЕНИЯ
let data = {
id: lib.hID.value,
code: lib.hCode.value,
title: lib.hTitle.value,
author: lib.hAuthor.value,
location: lib.hLoc.value
};
// (C2) СОХРАНИТЬ ИЛИ ОБНОВИТЬ
if (data.id == "") {
delete data.id;
lib.iTX().add(data);
} else {
data.id = parseInt(data.id);
lib.iTX().put(data);
}
// (C3) ВЫПОЛНЕНО
lib.toggle(false);
lib.draw();
return false;
},
// (D) УДАЛИТЬ ЗАПИСЬ
del : (id) => { if (confirm(`Delete ${id}?`)) {
// (D1) УДАЛИТЬ КНИГУ
lib.iTX().delete(id);
// (D2) СПИСОК ПЕРЕРАБОТКИ
lib.draw();
}},
// (E) СПИСОК КНИГ
draw : () => {
lib.hList.innerHTML = "";
lib.iTX().getAll().onsuccess = (evt) => { for (let book of evt.target.result) {
let row = document.createElement("div");
row.className = "row";
row.innerHTML = `<div class="binfo">
<div>
<p>Номер: ${book.id}</p>
<p>Серийный номер: ${book.code}</p>
</div>
<div>
<p>Название книги: ${book.title}</p>
<p>Автор: ${book.author}</p>
</div>
<p>расположение: ${book.location}</p>
</div>
<input type="button" class="mi" value="Удалить" onclick="lib.del(${book.id})"/>
<input type="button" class="mi" value="редактировать" onclick="lib.toggle(${book.id})"/>`;
lib.hList.appendChild(row);
}};
}
};
window.addEventListener("DOMContentLoaded", lib.init);